<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="位号" prop="devNo">
        <el-input
          v-model="queryParams.devNo"
          placeholder="请输入位号"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="位置" prop="position">
        <el-input
          v-model="queryParams.position"
          placeholder="请输入位置"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="年" prop="planYear">
        <el-date-picker
          v-model="year"
          :clearable="false"
          format="yyyy"
          placeholder="请选择年份"
          type="year"
          @change="handleQuery">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="月" prop="planQuarter">
        <el-date-picker
          v-model="month"
          :clearable="false"
          format="MM"
          placeholder="选择月"
          popper-class="picker-date"
          type="month"
          @change="handleQuery">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="计划名称" prop="planId">
        <el-select v-model="queryParams.planId" clearable
                   @change="handleQuery">
          <el-option v-for="item in planList"
                     :key="item.id"
                     :label="item.planName"
                     :value="item.id"/>
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['commonuse:safetyBelt:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="safetyBeltList"  :height="clientHeight" @selection-change="handleSelectionChange" border>
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="位号" align="center" prop="devNo" />
      <el-table-column label="位置" align="center" prop="position" />
      <el-table-column label="安全带腰带、背带的外观，无破损、变色、发霉、断线" align="center" prop="noDamage">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.inspection_status" :value="scope.row.noDamage"/>
        </template>
      </el-table-column>
      <el-table-column label="安全带扣件无松动，卡扣牢固可靠" align="center" prop="fastness">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.inspection_status" :value="scope.row.fastness"/>
        </template>
      </el-table-column>
      <el-table-column label="安全带缓冲安全绳及保护套" align="center" prop="protectiveJacket">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.inspection_status" :value="scope.row.protectiveJacket"/>
        </template>
      </el-table-column>
      <el-table-column label="编号准确，在有效期内" align="center" prop="validity">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.inspection_status" :value="scope.row.validity"/>
        </template>
      </el-table-column>
      <el-table-column label="确认人" align="center" prop="confirmed" />
      <el-table-column label="备注" align="center" prop="remarks" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            icon="el-icon-picture-outline"
            size="mini"
            type="text"
            @click="openFileDialog(scope.row)"
          >附件
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <el-dialog :close-on-click-modal="false":visible.sync="file.open" append-to-body title="附件详情" width="50%">
      <el-tabs v-model="tabName" :stretch="true" type="border-card">
        <el-tab-pane label="常规附件" name="a">
          <el-empty v-if="file.files.length==0" description="如你所见，这里什么都没有"></el-empty>
          <el-image v-for="url in file.files" v-else :key="url" :src="url"></el-image>
        </el-tab-pane>
        <el-tab-pane label="异常附件" name="b">
          <el-empty v-if="file.issuesFiles.length==0" description="如你所见，这里什么都没有"></el-empty>
          <el-image v-for="url in file.issuesFiles" v-else :key="url" :src="url"></el-image>
        </el-tab-pane>
        <el-tab-pane label="异常整改后附件" name="c">
          <el-empty v-if="file.repairFile.length==0" description="如你所见，这里什么都没有"></el-empty>
          <el-image v-for="url in file.repairFile" v-else :key="url" :src="url"></el-image>
        </el-tab-pane>
      </el-tabs>
    </el-dialog>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

  </div>
</template>

<script>
import { listSafetyBelt, getSafetyBelt, delSafetyBelt, addSafetyBelt, updateSafetyBelt } from "@/api/patrol/commonuse/safetyBelt";
import {listAllPlan} from "@/api/patrol/patrol/plan";

export default {
  name: "SafetyBelt",
  dicts: ['inspection_status'],
  data() {
    return {
      tabName: 'a',
      planList: [],
      file: {
        open: false,
        issuesFiles: [],
        repairFile: [],
        files: []
      },
      month: new Date(),
      year: new Date(),
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: false,
      // 页面高度
      clientHeight: 300,
      // 总条数
      total: 0,
      // 安全带表格数据
      safetyBeltList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 20,
        id: null,
        devNo: null,
        position: null,
        noDamage: null,
        fastness: null,
        protectiveJacket: null,
        validity: null,
        confirmed: null,
        remarks: null,
        checkStatus: null,
        checkDate: null,
        month: null,
        year: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        planId: null,
        problemFileUrl: null,
        fileUrl: null,
        issuesStatus: null,
        issuesFlag: null,
        repairFile: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    if (this.$route.query.year && this.$route.query.month) {
      this.year.setFullYear(this.$route.query.year, this.$route.query.month, 1);
      this.month.setMonth(this.$route.query.month, 1);
    }
    if (this.$route.query.planId) {
      this.queryParams.planId = parseInt(this.$route.query.planId)
    }
    if (this.$route.query.id) {
      this.queryParams.id = parseInt(this.$route.query.id)
      this.queryParams.issuesFlag = '1';
    }
    //设置表格高度对应屏幕高度
    this.$nextTick(() => {
      this.clientHeight = document.body.clientHeight - 270
    });

    if (!this.queryParams.id) {
      let query = {planQuarter: this.month.getMonth() + 1, planYear: this.year.getFullYear(), patrolType: '24'}
      listAllPlan(query).then(res => {
        this.planList = res.data;
        if (res.data.length > 0) {
          this.queryParams.planId = res.data[0].id;
        }
        this.getList();
      })
    }else{
      this.getList();
    }
  },
  methods: {
    openFileDialog(row) {
      this.tabName = 'a'
      this.file.issuesFiles = []
      this.file.files = []
      this.file.repairFile = []
      this.file.open = true;
      if (row.problemFileUrl)
        this.file.issuesFiles = row.problemFileUrl.split(',');
      if (row.fileUrl)
        this.file.files = row.fileUrl.split(',');
      if (row.repairFile)
        this.file.repairFile = row.repairFile.split(',');
    },
    getPlanList() {
      let query = {planQuarter: this.month.getMonth() + 1, planYear: this.year.getFullYear(), patrolType: '24'}
      listAllPlan(query).then(res => {
        this.planList = res.data;
      })
    },
    /** 查询安全带列表 */
    getList() {
      this.loading = true;
      if (!this.queryParams.id) {
        this.queryParams.month = this.month.getMonth() + 1;
        this.queryParams.year = this.year.getFullYear();
      }
      listSafetyBelt(this.queryParams).then(response => {
        this.safetyBeltList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        devNo: null,
        position: null,
        noDamage: null,
        fastness: null,
        protectiveJacket: null,
        validity: null,
        confirmed: null,
        remarks: null,
        checkStatus: null,
        checkDate: null,
        month: null,
        year: null,
        delFlag: null,
        createrCode: null,
        createdate: null,
        updaterCode: null,
        updatedate: null,
        deptId: null,
        planId: null,
        problemFileUrl: null,
        fileUrl: null,
        issuesStatus: null,
        issuesFlag: null,
        repairFile: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
      this.getPlanList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加安全带";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getSafetyBelt(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改安全带";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateSafetyBelt(this.form).then(response => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addSafetyBelt(this.form).then(response => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.confirm('是否确认删除安全带编号为"' + ids + '"的数据项？').then(function() {
        return delSafetyBelt(ids);
      }).then(() => {
        this.getList();
        this.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download2('commonuse/safetyBelt/export', {
        ...this.queryParams
      }, `safetyBelt_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
